package dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special;

import java.util.function.Function;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.kinds.App;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import com.google.common.base.Preconditions;
import net.minecraft.ChatFormatting;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import net.minecraft.network.chat.Component;
import net.minecraft.tags.DamageTypeTags;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.item.ItemStack;
import java.util.Set;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass;
import com.google.common.collect.ImmutableSet;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.placebo.util.StepFunction;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import java.util.Map;
import com.mojang.serialization.Codec;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;

public class MageSlayerBonus extends GemBonus
{
    public static Codec<MageSlayerBonus> CODEC;
    protected final Map<LootRarity, StepFunction> values;
    
    public MageSlayerBonus(final Map<LootRarity, StepFunction> values) {
        super(Apotheosis.loc("mageslayer"), new GemClass("helmet", (Set)ImmutableSet.of(LootCategory.HELMET)));
        this.values = values;
    }
    
    public float onHurt(final ItemStack gem, final LootRarity rarity, final DamageSource src, final LivingEntity user, final float amount) {
        final float value = this.values.get(rarity).min();
        if (src.m_269533_(DamageTypeTags.f_268490_)) {
            user.m_5634_(amount * value);
            return amount * (1.0f - value);
        }
        return super.onHurt(gem, rarity, src, user, amount);
    }
    
    public Codec<? extends GemBonus> getCodec() {
        return MageSlayerBonus.CODEC;
    }
    
    public Component getSocketBonusTooltip(final ItemStack gem, final LootRarity rarity) {
        final float value = this.values.get(rarity).min();
        return (Component)Component.m_237110_("bonus." + this.getId() + ".desc", new Object[] { Affix.fmt(value * 100.0f) }).m_130940_(ChatFormatting.YELLOW);
    }
    
    public MageSlayerBonus validate() {
        Preconditions.checkNotNull(this.values);
        this.values.forEach((k, v) -> {
            Preconditions.checkNotNull(k);
            Preconditions.checkNotNull(v);
            return;
        });
        return this;
    }
    
    public boolean supports(final LootRarity rarity) {
        return this.values.containsKey(rarity);
    }
    
    public int getNumberOfUUIDs() {
        return 0;
    }
    
    static {
        MageSlayerBonus.CODEC = (Codec<MageSlayerBonus>)RecordCodecBuilder.create(inst -> inst.group((App)MageSlayerBonus.VALUES_CODEC.fieldOf("values").forGetter(a -> a.values)).apply((Applicative)inst, (Function)MageSlayerBonus::new));
    }
}
